;;; DO NOT MODIFY THIS FILE
(if (featurep 'vc-custom-defines) (error "Feature vc-custom-defines already loaded"))

;;;### (autoloads (vc-mode-face vc-ignore-vc-files vc-mistrust-permissions vc-keep-workfiles vc-consult-headers vc-display-status vc-follow-symlinks vc-make-backup-files vc-master-templates vc-path vc-rcsdiff-knows-brief vc-handle-cvs vc-default-back-end) "vc-hooks" "vc/vc-hooks.el")
(defconst custom-define-current-source-file "vc-hooks.el")

(defcustom vc-default-back-end nil "\
*Back-end actually used by this interface; may be SCCS or RCS.
The value is only computed when needed to avoid an expensive search." :type '(choice (const nil) (const RCS) (const SCCS)) :group 'vc)

(defcustom vc-handle-cvs t "\
*If non-nil, use VC for files managed with CVS.
If it is nil, don't use VC for those files." :type 'boolean :group 'vc)

(defcustom vc-rcsdiff-knows-brief nil "\
*Indicates whether rcsdiff understands the --brief option.
The value is either `yes', `no', or nil.  If it is nil, VC tries
to use --brief and sets this variable to remember whether it worked." :type '(choice (const nil) (const yes) (const no)) :group 'vc)

(defcustom vc-path (if (file-directory-p "/usr/sccs") '("/usr/sccs") nil) "\
*List of extra directories to search for version control commands." :type '(repeat directory) :group 'vc)

(defcustom vc-master-templates '(("%sRCS/%s,v" . RCS) ("%s%s,v" . RCS) ("%sRCS/%s" . RCS) ("%sSCCS/s.%s" . SCCS) ("%ss.%s" . SCCS) vc-find-cvs-master vc-search-sccs-project-dir) "\
*Where to look for version-control master files.
The first pair corresponding to a given back end is used as a template
when creating new masters.
Setting this variable to nil turns off use of VC entirely." :type '(repeat sexp) :group 'vc)

(defcustom vc-make-backup-files nil "\
*If non-nil, backups of registered files are made as with other files.
If nil (the default), files covered by version control don't get backups." :type 'boolean :group 'vc)

(defcustom vc-follow-symlinks 'ask "\
*Indicates what to do if you visit a symbolic link to a file
that is under version control.  Editing such a file through the
link bypasses the version control system, which is dangerous and
probably not what you want.  
  If this variable is t, VC follows the link and visits the real file,
telling you about it in the echo area.  If it is `ask', VC asks for
confirmation whether it should follow the link.  If nil, the link is
visited and a warning displayed." :type '(choice (const ask) (const nil) (const t)) :group 'vc)

(defcustom vc-display-status t "\
*If non-nil, display revision number and lock status in modeline.
Otherwise, not displayed." :type 'boolean :group 'vc)

(defcustom vc-consult-headers t "\
*If non-nil, identify work files by searching for version headers." :type 'boolean :group 'vc)

(defcustom vc-keep-workfiles t "\
*If non-nil, don't delete working files after registering changes.
If the back-end is CVS, workfiles are always kept, regardless of the
value of this flag." :type 'boolean :group 'vc)

(defcustom vc-mistrust-permissions nil "\
*If non-nil, don't assume that permissions and ownership track 
version-control status.  If nil, do rely on the permissions.
See also variable `vc-consult-headers'." :type 'boolean :group 'vc)

(defcustom vc-ignore-vc-files nil "\
*If non-nil don't look for version control information when finding files.

It may be useful to set this if (say) you edit files in a directory
containing corresponding RCS files but don't have RCS available;
similarly for other version control systems." :type 'boolean :group 'vc)

(defcustom vc-mode-face 'highlight "\
*Face used to display vc mode line, or nil/default for none" :type 'face :group 'vc)

;;;***

;;;### (autoloads (vc-cvs-program vc-cvs-release vc-sccs-release vc-rcs-release vc-checkout-carefully vc-comment-alist vc-static-header-alist vc-header-alist vc-annotate-mode-hook vc-log-template vc-populate-vc-log-hook vc-before-checkin-hook vc-checkin-hook vc-annotate-menu-elements vc-annotate-background vc-annotate-very-old-color vc-annotate-color-map vc-file-not-found-use-default vc-default-init-version vc-directory-exclusion-list vc-create-initial-rcs-dir vc-register-switches vc-checkout-switches vc-checkin-switches vc-command-messages vc-initial-comment vc-suppress-confirm vc) "vc" "vc/vc.el")
(defconst custom-define-current-source-file "vc.el")

(defgroup vc nil "Version-control system in Emacs." :group 'tools)

(defcustom vc-suppress-confirm nil "\
*If non-nil, treat user as expert; suppress yes-no prompts on some things." :type 'boolean :group 'vc)

(defcustom vc-initial-comment nil "\
*If non-nil, prompt for initial comment when a file is registered." :type 'boolean :group 'vc)

(defcustom vc-command-messages nil "\
*If non-nil, display run messages from back-end commands." :type 'boolean :group 'vc)

(defcustom vc-checkin-switches nil "\
*A string or list of strings specifying extra switches for checkin.
These are passed to the checkin program by \\[vc-checkin]." :type '(choice (const :tag "None" nil) (string :tag "Argument String") (repeat :tag "Argument List" :value ("") string)) :group 'vc)

(defcustom vc-checkout-switches nil "\
*A string or list of strings specifying extra switches for checkout.
These are passed to the checkout program by \\[vc-checkout]." :type '(choice (const :tag "None" nil) (string :tag "Argument String") (repeat :tag "Argument List" :value ("") string)) :group 'vc)

(defcustom vc-register-switches nil "\
*A string or list of strings; extra switches for registering a file.
These are passed to the checkin program by \\[vc-register]." :type '(choice (const :tag "None" nil) (string :tag "Argument String") (repeat :tag "Argument List" :value ("") string)) :group 'vc)

(defcustom vc-create-initial-rcs-dir nil "\
*If non-nil and there is no ./RCS subdirectory yet, create it." :type 'boolean :group 'vc)

(defcustom vc-directory-exclusion-list '("SCCS" "RCS" "CVS") "\
*List of directory names to be ignored while recursively walking file trees." :type '(repeat string) :group 'vc)

(defcustom vc-default-init-version nil "\
*A string giving the default version number for the function `vc-register'.
If `nil' (default), the choice of initial version is left to the
version control program.  Can be overridden by giving a prefix
argument to `vc-register'." :type '(choice (const :tag "Auto" nil) (string :tag "Version")) :group 'vc)

(defcustom vc-file-not-found-use-default nil "\
*If non-nil, just check out the default version.
If `nil', then this will use the working file when checking out an
unfound file." :type 'boolean :group 'vc)

(defcustom vc-annotate-color-map '((26.3672 . "#FF0000") (52.7344 . "#FF3800") (79.1016 . "#FF7000") (105.4688 . "#FFA800") (131.8359 . "#FFE000") (158.2031 . "#E7FF00") (184.5703 . "#AFFF00") (210.9375 . "#77FF00") (237.3047 . "#3FFF00") (263.6719 . "#07FF00") (290.0391 . "#00FF31") (316.4063 . "#00FF69") (342.7734 . "#00FFA1") (369.1406 . "#00FFD9") (395.5078 . "#00EEFF") (421.875 . "#00B6FF") (448.2422 . "#007EFF")) "\
*Association list of age versus color, for \\[vc-annotate].
Ages are given in units of 2**-16 seconds.
Default is eighteen steps using a twenty day increment." :type 'sexp :group 'vc)

(defcustom vc-annotate-very-old-color "#0046FF" "\
*Color for lines older than CAR of last cons in `vc-annotate-color-map'." :type 'string :group 'vc)

(defcustom vc-annotate-background "black" "\
*Background color for \\[vc-annotate].
Default color is used if nil." :type 'string :group 'vc)

(defcustom vc-annotate-menu-elements '(2 0.5 0.1 0.01) "\
*Menu elements for the mode-specific menu of VC-Annotate mode.
List of factors, used to expand/compress the time scale.  See `vc-annotate'." :type 'sexp :group 'vc)

(defcustom vc-checkin-hook nil "\
*Normal hook (List of functions) run after a checkin is done.
See `run-hooks'." :type 'hook :group 'vc)

(defcustom vc-before-checkin-hook nil "\
*Normal hook (list of functions) run before a file gets checked in.  
See `run-hooks'." :type 'hook :group 'vc)

(defcustom vc-populate-vc-log-hook nil "\
*Normal hook (list of functions) run after the VC log buffer is created.  
This can be used to insert a template in to the VC log buffer for the user
to edit.

For example the following will prepare the VC log buffer with the
text `BugID:' and leave the cursor ready to enter the bug number.
\(add-hook 'vc-after-log-create-hook 'vc-populate-vc-log-with-goto-first-eol)
\(add-hook 'vc-after-log-create-hook 'vc-populate-vc-log-with-template)
\(setq vc-log-template \"BugID: \\n\")

See `run-hooks' and `vc-populate-vc-log-with-template'." :type 'hook :group 'vc)

(defcustom vc-log-template "" "\
*Template text to insert in to a version control log.
See `vc-populate-vc-log-hook'." :type 'string :group 'vc)

(defcustom vc-annotate-mode-hook nil "\
*Hooks to run when VC-Annotate mode is turned on." :type 'hook :group 'vc)

(defcustom vc-header-alist '((SCCS "%W%") (RCS "$Id$") (CVS "$Id$")) "\
*Header keywords to be inserted by `vc-insert-headers'.
Must be a list of two-element lists, the first element of each must
be `RCS', `CVS', or `SCCS'.  The second element is the string to
be inserted for this particular backend." :type '(repeat (list :format "%v" (choice :tag "System" (const SCCS) (const RCS) (const CVS)) (string :tag "Header"))) :group 'vc)

(defcustom vc-static-header-alist '(("\\.c$" . "\n#ifndef lint\nstatic char vcid[] = \"%s\";\n#endif /* lint */\n")) "\
*Associate static header string templates with file types.  A %s in the
template is replaced with the first string associated with the file's
version-control type in `vc-header-alist'." :type '(repeat (cons :format "%v" (regexp :tag "File Type") (string :tag "Header String"))) :group 'vc)

(defcustom vc-comment-alist '((nroff-mode ".\\\"" "")) "\
*Special comment delimiters to be used in generating vc headers only.
Add an entry in this list if you need to override the normal comment-start
and comment-end variables.  This will only be necessary if the mode language
is sensitive to blank lines." :type '(repeat (list :format "%v" (symbol :tag "Mode") (string :tag "Comment Start") (string :tag "Comment End"))) :group 'vc)

(defcustom vc-checkout-carefully (= (user-uid) 0) "\
*Non-nil means be extra-careful in checkout.
Verify that the file really is not locked
and that its contents match what the master file says." :type 'boolean :group 'vc)

(defcustom vc-rcs-release nil "\
*The release number of your RCS installation, as a string.
If nil, VC itself computes this value when it is first needed." :type '(choice (const :tag "Auto" nil) string) :group 'vc)

(defcustom vc-sccs-release nil "\
*The release number of your SCCS installation, as a string.
If nil, VC itself computes this value when it is first needed." :type '(choice (const :tag "Auto" nil) string) :group 'vc)

(defcustom vc-cvs-release nil "\
*The release number of your CVS installation, as a string.
If nil, VC itself computes this value when it is first needed." :type '(choice (const :tag "Auto" nil) string) :group 'vc)

(defcustom vc-cvs-program "cvs" "\
*Executable to run for CVS commands." :type 'file :group 'vc)

;;;***

(provide 'vc-custom-defines)
